# CNCF Mentoring Initiatives

The Cloud Native Computing Foundation (CNCF) participates in a variety of mentoring programs. CNCF is a great place to spend time learning, coding, documenting, participating, and contributing. We look forward to your application and your project ideas!

This repository contains resources and information for the CNCF Mentoring Program. The program is designed to match experienced mentors with mentees who are interested in learning about cloud native technologies and contributing to open source projects in the ecosystem.

## Resources
In this repository, you will find a number of resources to help you get started and make the most of your mentoring experience. 

These include:

The [mentors](/mentors#readme) and [mentees](mentees#readme) folders provide guidance on how to be an effective mentor or mentee.
The [programs](/programs#readme) folder provides a list of programs for mentees to work on with their mentors.
This initiative is guided by the [CNCF Mentoring Subproject](/cncf-toc-mentoring-subproject#readme). More information about meetings, communication and activities can be found in the  [cncf-toc-mentoring-subproject](/cncf-toc-mentoring-subproject#readme) section of this repository.

## Participation
Participation in the CNCF Mentoring Program is open to anyone who is interested in learning about cloud native technologies and contributing to open source projects in the ecosystem.

Contact
If you have any questions or need help getting started, please reach out through our various [communication channels](/mentoring-wg/communications.md).

## Mentoring Programs

| Program                                                                  | Purpose                                                                           | Details and historical data                       |
| ------------------------------------------------------------------------ | --------------------------------------------------------------------------------- | ------------------------------------------        |
| [LFX Mentorship](https://mentorship.lfx.linuxfoundation.org)             | Mentoring initiative by the Linux Foundation                                      | [lfx-mentorship](/programs/lfx-mentorship#readme) |
| [Google Summer of Code](https://summerofcode.withgoogle.com/)            | Mentoring program for open source beginners                                       | [summerofcode](/programs/summerofcode#readme)     |
| [Outreachy](https://www.outreachy.org)                                   | Mentoring initiative for the communities traditionally underrepresented in tech   | [outreachy](/programs/outreachy#readme)           |

## Program Statistics

These are the number of successful internships per year for each program.

| Year | Program                          | Internships | Total (per year) |
|------|----------------------------------|-------------|------------------|
| 2025 | LFX Mentorship                   | 64          | 64 (so far)      |
|      | GSoC                             | 11          |                  |
| 2024 | LFX Mentorship                   | 134         | 147              |
|      | GSoC                             | 11          |                  |
|      | Outreachy                        | 2           |                  |
| 2023 | LFX Mentorship                   | 127         | 144              |
|      | GSoC                             | 14          |                  |
|      | GSoD                             | 2           |                  |
|      | Outreachy                        | 1           |                  |
| 2022 | LFX Mentorship                   | 87          | 106              |
|      | GSoC                             | 16          |                  |
|      | GSoD                             | 3           |                  |
| 2021 | LFX Mentorship                   | 86          | 104              |
|      | GSoC                             | 16          |                  |
|      | GSoD                             | 1           |                  |
|      | Outreachy                        | 1           |                  |
| 2020 | LFX Mentorship (CommunityBridge) | 50          | 71               |
|      | GSoC                             | 16          |                  |
|      | GSoD                             | 4           |                  |
|      | Outreachy                        | 1           |                  |
| 2019 | CommunityBridge                  | 4           | 20               |
|      | GSoC                             | 15          |                  |
|      | Outreachy                        | 1           |                  |
| 2018 | GSoC                             | 7           | 8                |
|      | Outreachy                        | 1           |                  |
| 2017 | GSoC                             | 6           | 8                |
|      | Outreachy                        | 2           |                  |

## Code of Conduct

Please note that CNCF Mentoring programs follow the [CNCF Code of Conduct](https://github.com/cncf/foundation/blob/master/code-of-conduct.md). By participating in this project you agree to abide by its terms.

## Thank you for participating in the CNCF Mentoring Program!

