---
title: TAGCS Mentoring Working Group Monthly Meeting (2022)
tags: Meeting Minutes, 2022
---

This file has been archived. Please find the [2023 meeting minutes here](https://hackmd.io/@tag-cs-mentoring-wg/monthly-meeting-2023).

[![hackmd-github-sync-badge](https://hackmd.io/7vA7fKNrRG6KrGbA01oupw/badge)](https://hackmd.io/7vA7fKNrRG6KrGbA01oupw)


CNCF TAG Contributor Strategy
# Mentoring Working Group


## About TAGCS Mentorship Working Group

* [Primary repository](https://github.com/cncf/mentoring)
* CNCF Slack: [#tag-contributor-strategy](https://cloud-native.slack.com/archives/CT6CWS1JN)
* [Discussion boards](https://github.com/cncf/mentoring/discussions)
* [Email list](https://lists.cncf.io/g/tag-cs-mentoring-wg/)


## Meeting details

### Recurring monthly
* 2nd Tuesday of the month at 9PM UTC
* 4th Tuesday of the month at 9PM UTC (during the setup phase)

[CNCF Public Events - TAG CS Mentoring WG](https://tockify.com/cncf.public.events/monthly?search=CNCF%20TAG%20Contributor%20Strategy%20Mentoring%20WG)

### Zoom

Zoom Meeting  
https://zoom.us/my/cncftagcontributorstrategy?pwd=TnI0WU9Eb2I1RlRWdkl1R0k1WkZXUT09

Passcode: 77777


# Past Meetings

## Dec 13, 2022

21:00 UTC (1:00 PM PDT on 2022-12-13; 10:00 AM NZST on 2022-12-14)  

### Attendance

* Nate W.
* Jay Tihema
* Riaan Kleinhans
* Josh Berkus
* Victor Lu
* 


### Updates/reminders

* 

### Agenda
* General Progress report
    * Mentoring programs
      * 2022 diversity data: https://github.com/cncf/workflow/issues/332 (please reach out to Nate W. if you don't have access to the document).
    * Mentoring repo
      * Outreachy engagement
      * Possible alignment w/ Contributor.io
* Plans for 2023
  * Goals
    * What are our specific goals around diversity?
      * do we want more folks from different places?
      * do we want more non-male mentees?
      * do we want a wider range of ages represented?
    * reach out to LF Research team to participate and help us design 
    * discuss with LF privacy
  
### Notes
* Shared location previously, DE&I data has now been collated as well, meaning we can now potentially see patterns in engagement from past years
* Possible split between mechanical and informational content for Repo
* We can help develop Contributor-specific content for the site
* Mentoring stuff under 'Maintainer' or mentoring-specific; 
    * Where would the most beneficial place to host this; should be intertwined w/ Contributor focus in general
* Maintainers link - joining a program

Mentoring Uptake 2022
* General improvement in participation; unsure of what to attribute this increase to directly
* How to encourage more diversity in applications and selections?
    * Specific goals/targets needed - more global reach, non-male mentees, career-changers vs. early students etc. 
    * Would be beneficial to gauge feedback from the community, LF research team etc.
    * Should also be exposed to Mentors; navigate privacy etc. to help determine applicant diversity
General project numbers increasing
* Challenge to increase to 150 mentees in 2023
* Maintainers need to be considered throughout to avoid burnout; support health & wellbeing
Current LFX doesn't filter effectively
* More applications per project might be 'fatal'; grow from projects first to support maintainer evaluations
**What might be other good goals for 2023?**
* website alignment
* increasing diversity
* mentee numbers
* organised effort around CLOtributor including mentor availability - develop a template of what that could look like


---


## Nov 22, 2022

21:00 UTC (1:00 PM PDT on 2022-11-22; 10:00 AM NZST on 2022-11-23)  

### Attendance

* Nate W.
* Jay Tihema
* Riaan Kleinhans
* Alexandre N.

### Updates/reminders

* n/a

### Agenda

* LFX Mentoring Term 3: Sept-Nov completing this week
  * stipends are getting paid out
  * mentee survey sent out (no responses yet)
  * TODO:
    * Update repo with new statistics/results
    * reach out to CNCF marketing (Jesse) 
* [GSoC 2023 Timeline](https://developers.google.com/open-source/gsoc/timeline)
* Outreachy
  * Looks like OTel will be doing 2 projects (CNCF funding one), starts Jan 2023
  * We should contact Outreachy and see if there is an org option for participation
* GSoD - still showing 2022 timeline, but we should keep an eye out for when they start their 2023 program.
* Mentoring Repo review
    * [Moved archive info form readme to the archive file #744](https://github.com/cncf/mentoring/pull/744)
    * [Next steps for Mentee section #737](https://github.com/cncf/mentoring/issues/737)
    * [Next steps for Mentor section #736](https://github.com/cncf/mentoring/issues/736)
    * https://hackmd.io/80wBLa5WSx6pTOUGXXleTg - draft mentee section

**Notes**
* GSoC deadlines critical - steps to be taken to meet these. 
* **TODO** - Create a calendar for CNCF Mentoring; collect dates for mentoring Programs where timeline can be developed
* Nate may be able to action; will check w/ Amye - CNCF permission needed
    * [Public Mentoring Calendar #741
](https://github.com/cncf/mentoring/issues/741)
* **Outreachy update** - Otel will be doing two projects; one is CNCF funded - volunteers from team should contact their team to learn more about the program.
    * 'Research Round' needed prior to learn more about programme then reach out to request meeting
* **Repo:** 
    * Key notes first then look at refactoring ReadMe etc. 
    * Keep 2022 as a live file, as opposed to an archived file; keep a year's worth of content oepn for access/review
    * Add a ticket to create a proper Readme for the front page once all links are finalised
    * Archives should rigidly stay as they are to retain integrity of history e.g. program seasons; unless it becomes/is a security risk
        * Establish some standard of record of changes to track/monitor analytics e.g. stats etc. for new work incoming. 
        * e.g. some sub-folders assigned 'per year' under project folders
        * May be difficult with each Program running at its own cadence 
    * Detail to be re-populated in ReadMe (currently empty)
    * Repo to be refactored to include new statistics e.g. project numbers
    * Repo reorganised to downsize number of folders, key info outlined in ReadMe
    * Nate to support with high-level detail 
        * Can this be used as a documentation framework - part of this purpose is to align with (likely) the Contributor.io website 
        * Once ready and approved by team we can contact w/ Chris Abrams to assess linking w/ site
* KubeCon Maintainer Track talks should still be available for submissions
* Alexandre to start Contributor Board match-making (C-S initiative); connect people wanting to contrib and build experience towards a system that links projects, maintainers etc. (not Mentoring-specific) - research, feedback etc.


## Nov 8, 2022

21:00 UTC (1:00 PM PDT on 2022-11-08; 10:00 AM NZST on 2022-11-09)  
**Note**, the end of Daylight Saving Time in NA has affected the time of this meeting.

### Attendance

* Nate W.
* Jay Tihema
* Alexandre N.
* Riaan Kleinhans

### Updates/reminders

* 

### Agenda

* [KubeCon 2023 EU CFP](https://events.linuxfoundation.org/kubecon-cloudnativecon-europe/program/cfp/)
  * Deadline for CFP is Nov 18. Do we want to have a mentoring talk?

* Repo Refactor

**Notes:**

**Kubecon EU Talk CFP**
* Possible workshop on how to put together a proposal, how to select a good scope of work - invite others to discuss potential projects e.g. mentorship proposal 'how to'
* CFP required only - Repo refactor possible; not expected to "do the work before doing the work"
* 'Speed Mentoring' - mentoring 'in general' e.g. how does it work vs. specific projects
    * Mentoring information session to educate on the detail of 'what?'
    * 2nd phase - connect with the mentor directly to learn more about processes etc. 
    * Mentee information session - receiving more students; provide support for newcomers

*Volunteer to provide individual career guidance as an extension of this.*

**To-do:** CNCF Events team (?) and figure out who runs speed mentoring , maybe not be a CFP-level decision. Also gives others a chance to start notifying mentees/tors. 

**Mentoring Repo Refactor**

Current refactor underway; general content/focus includes:

**Mentors:** How do I make a proposal?
**Mentees:** how do I get involved etc.?

V2 branch and several issues in development. 

*Can promote/update this work in Slack for others to contribute/provide feedback on.*

***


## October 25 - at KubeCon (either in person or online)

20:00 UTC (1:00 PM PDT on 2022-10-25; 8:00 AM NZST on 2022-10-26)

### Attendance

* Nate W.
* Jay Tihema
* Riaan Kleinhans

### Updates/reminders

* KubeCon this week

### Agenda

* Repo chat
* Talk tomorrow


## Oct 11, 2022

20:00 UTC (1:00 PM PDT on 2022-10-11; 9:00 AM NZST on 2022-10-12)

### Attendance

* Nate W.
* Jay Tihema
* Alexandre N.
* Riaan Kleinhans

### Updates/reminders

* KubeCon maintainers track talk
  * Presentation Upload to Sched Deadline: **Friday, October 14**
  * [Google slides](https://docs.google.com/presentation/d/1dssl7RbFX64Eo3BbkWZll6nc03tWsEag2GEZWzh3HbA/edit?usp=sharing)
  * [Notes from working session](https://hackmd.io/@nate-double-u/mentoring-wg-kubecon-22-na)
* CNCF LFX Mentorship Term 3: Sept-Nov midterm
  * Nate W. working through stipends with mentees
  * 1 withdrawal
  * 24/24 remaning projects/mentees are passing
* GSoC 2022
  * 2 projects ongoing
  * One finishes Oct 17, the other Nov 14
* NZ progress 
    * Community Digital Infrastructure
* General 
    * Cloud Native Students (Kunal)
    * Pathway mapping, Repo > website

stories from LFX Mentorship last term:
* https://www.cncf.io/blog/2022/07/07/cncf-congratulates-36-successful-interns-with-spring-term-lfx-program/

### Agenda


### Notes/Actions
* Project to help map academic progression - TBC, Alexandre and Nate to investigate - ChaoSS community
* https://github.com/chaoss
* https://chaoss.community/
* Also maps project health but from an academic standpoint; contribution lifecycles e.g, menteeship etc.
* Nate managing spreadsheets re LFX etc. due to sensitive information such as payment details
* Need to plan Term 1 for 2023, before CTA at Kubecon; inviting Maintainers to make project suggestions in the corresponding Repo *(26m onwards - video ref)*
* Not explicit that work conducted during mentorships made visible in known repo *(31m)*
* As part of process, should request that project pages should be updated accordingly to reflect changes
* Move/shutdown of #mentoring channel on Slack to address bot update issue - Nate will investigate as CNCF admin. Desire to move community into Github discussions board owing to comms limitations in Slack; preference to have a central space for core comms.
> [name=Nate W.][time=Thu, Oct 13, 2022 9:17 AM] Followup: The bot has been removed.
* Organisational discussions in TAG-CS etc.


## Sept 27, 2022

20:00 UTC (1:00 PM PDT on 2022-09-27; 9:00 AM NZST on 2022-09-28)

### Attendance

* Nate W.
* Jay Tihema
* Alexandre N.
* Riaan Kleinhans
* Josh Berkus

### Updates/reminders

* CNCF students (previous meeting) https://community.cncf.io/cloud-native-students/
* Kunal Kushwaha may be involved?

### Agenda

* Outreachy - recruit someone to help run this program?
* "Community responsibility"
* Strategic overview
  * https://docs.google.com/presentation/d/1cL0ZwzigoGNqFIDuuJ_Daz_4x2RXgeRK/edit?usp=sharing&ouid=107340980254524659898&rtpof=true&sd=true
    * Should be addressed through TAG issues i.e. Mentoring Repo or a project board
* Contributor Opportunities board
* Working session for KubeCon Mentorship talk/session (last half of meeting)

---
### **Notes**

**Outreachy** - some interest in Kubernetes etc.; Josh suggested might be of value from someone in the community to support with Outreachy 

* Ideally someone who would reach out to various programs to gauge interest
* May be more 'participant-driven' - Ambassador-type role, help with administration
* Put a call-out on (TAG Contributor Strategy) mailing list and chat channel to encourage a response
* May escalate to TOC list
* Would be good to implement same thing (not yet K8s) - treat short-term internship opps...
* Timing is key between programs (as well as overhead)
* No current plan exists to 'improve' LFX - or to be executed
* Outreachy - up to 3 admins; you don't have to cancel your own admin rights to action that
* Q: *What's the CNCF funding situation for Outreachy?* 
    * (K8s sorted but status of other projects?) - Nate to follow-up; need to know before recruitment call goes out.
    * LFX accepts direct donations, built-in funding mechanism. No compensation for mentors; sometimes for Outreachy - often dependent as to whether mentor is currently in employment etc.
    * Smallest staff-base which may restrict access/availability in certain countries, can also affect payment.
    
* todo: list (or collect lists) countries that we support internships in


**GSoC** - **'Community responsibility'**
https://docs.google.com/presentation/d/1YKEEIGZPlTQtlggtNDEf-_BU718Sr9aQH4WDs1fpL0s/edit?usp=sharing -- slide ~68
https://github.com/cncf/tag-contributor-strategy/tree/main/mentoring

* Detail not currently reflected in Charter: 
    - https://docs.google.com/document/d/1B_hpVAKxxNaSgVYAsHdjq_57eZEkYUuxcxecbcl3H9c/edit
    - https://github.com/cncf/tag-contributor-strategy/tree/main/mentoring
* Potentially help in developing Mission Statement etc. 
    "promote growth and sustainability for projects through mentoring new and existing contributors"
    "provide support and advice for the projects"
    
* Open a new PR with proposed changes to the statement - need to bounce to liaisons for final approval.
    * Update to mission statement proposal:
https://github.com/Riaankl/tag-contributor-strategy/compare/main...Update-Mission-statement 
        - https://github.com/cncf/tag-contributor-strategy/pull/236

**Contributor Opportunities board**
* Not a project with a deadline attached
* Past efforts i.e. K8s have failed
* Better to engage with wider community over time to improve chances of success and quality
* Contributor Survey will help to identify focus areas in the meantime
* One of the biggest obstacles is encouraging Maintainers etc. to keep info up-to-date; how can we make it easy for them to do so?
* Building something new immediately implies/requires maintenance

**Mentoring Website**
* Should be a part of Contributor website
* Request help w/ mentoring discussions board - common Q is 'how to get started'? - use for discussion vs. using #mentoring Slack
* 'Getting Started' page would provide value
* Two main constituents are (new) Contributors and Maintainers - 
*Tentative actions:*
    * research what's available in mentoring in repo
    * build out diagram to map/canvas contents
    * figure out what's wanted/needed
    * look at existing Contributor.io infrastructure and determine what should be integrated


## Sept 13, 2022

20:00 UTC (1:00 PM PDT on 2022-09-13; 8:00 AM NZST on 2022-09-14)

### Attendance

* Natali Vlatko
* Alexandre Nicastro
* Jay Tihema
* Riaan Kleinhans

### Updates/reminders

* https://docs.google.com/presentation/d/1cL0ZwzigoGNqFIDuuJ_Daz_4x2RXgeRK/edit?usp=sharing&ouid=107340980254524659898&rtpof=true&sd=true

### Agenda

* Strategy Draft
    * Main areas:
        * Culture
        * Knowledge
        * Systems & Processes
    * LFX mentorship:Season three
        * Propose a pre and post program increase of activity to support the "Mentorship lifecycle".
        * Mentees becoming mentors
    * AI: Jay: Share the slides from the meeting with the community.

* Website
    * Engaging with Charley Mann
    * Looking at creating a Mentoring website after the pattern of Contributor web site
    * resource listing on the site linking all areas that engage with Mentoring
    * [Natali] https://community.cncf.io/cloud-native-students/ is still active.
        * Would be a good point of engagement.



---


### August 23, 2022
20:00 UTC (1:00 PM PDT on 2022-08-23; 8:00 AM NZST on 2022-08-24)

### Attendance

* Jay Tihema
* Josh Berkus
* Hippie Hacker
* Alexandre Nicastro
* Riaan Kleinhans

### Updates/reminders

* [Recent events](https://sunlive.co.nz/news/301041-tauranga-helping-young-women-into-it-careers.html) (Canvas, STTS, KHM)
* CloudNative.nz site 
* Mentoring info session at ii [Meetup event](https://www.meetup.com/cloudnative-nz/events/287887918/)

### Agenda

* Revisiting focus
* WG participation/actions
* Supporting messaging/engagement for potential contributors


### Notes

**Optimising Channels**
* Potential split/separation between communication and GitHub app comms/bot; establish a thread
* Separate #'Mentoring Bot' etc. - can the bot be configured accordingly?
* Separate channel for TAG Contributor Strategy - process for infrastructure change? Wait until Nate's back to review.  Probably create #tag-cs-notices, direct all auto traffic to that
> [name=Nate W.]
> [time=Thu, Aug 25, 2022 3:32 PM] I question if we need the github/slack notifications bot at all. I'll look into the historical rationale for it. We have been trying to push towards using https://github.com/cncf/mentoring/discussions instead of slack for comms with mentees/potential mentees.

**Managing Engagement**
* Hippie receiving alot of contact re LFX project including questions, CVs etc. - how to best manage comms
* Possible CRM to manage communications - HubSpot, AirTable etc. - spreadsheet can be difficult to modify later if/when needed. Can adjust later as required
* Steps/processes may be unclear to mentees e.g., project submission, redirection, balancing correspondence.
* Need to review existing LFX systems - consider legalities as mentees are technically short-term 'employees'; 
> [name=Nate W.] 
> [time=Thu, Aug 25, 2022 3:04 PM] Mentees are specifically _not_ employees (https://docs.linuxfoundation.org/lfx/mentorship/mentees): "NOTE: Mentees are not employed by the Linux Foundation. The Linux Foundation’s employment opportunities are available at https://www.linuxfoundation.org/about/careers."  
> I agree we should review and understand what mentee status actually is.
* Recognising two channels w/ mentoring: 
    1. increasing awareness for new/potential contributors 
    1. the need for the WG to be proactive in reaching out to those already in the ecosystem 
* Most projects may not be aware this initiative exists - share success stories as often as possible to help provide clarity; can we create blogs, interviews etc. to do this?

**Strategy & Resource/Knowledge Base**
* Need to create strategy to build a culture and community around mentorship; if people become involved, how can we share positive experiences and develop a 'flow' within community.
* Possible platform to share knowledge - when the program runs there are likely to be similar questions among participants; GitHub etc? Need to decide appropriate platform, learn from past mentorships
    * e.g. Mentorship experience - how to make a PR, mentee/mentor public profiles, Q&As (categorised) - can iterate over time
* **Can Contributor Docs be written in a way that are more beneficial for maintainers**, current documentation doesn't exist; direct mentee/mentor engagement can be more difficult
* Can possibly be implemented together - current lack of building tools from CNCF/LF.
* Support mentors in providing resources for mentees e.g. markdown docs on GitHub, search function i.e. Develop template - see existing Contributor Guide templates
    * Difficulties in explaining e.g. PRs processes, providing clear examples would help alot towards this
    * **The obstacle is getting the guide written in the first place!** e.g. can a question raised in Slack become a bulletpoint in the guide.
* Inventory of existing resources - what are permissions for partnerships, collaboration etc. 
* Not sure of known policies re exclusive permissions - does someone have a knowledge-base app to support
* **Objective is to optimise Mentors' time**; source key info for easy mentee reference 
* Scope for CNCF funding - more for knowledge-base for Sandbox projects, separate for NZ projects

#### Next Actions:
* Follow up w/ Nate: recommended LFX mentee engagement process to clarify mentor communication/interaction
* Map mentee/mentor pathway to identify onboarding journey and areas for focus/improvement 
* Draft strategy doc 
* Stocktake of existing processes, resources, knowledge bases
* List common barriers to new contributors
* Investigate separation of Mentoring channel - general communications from GitHub bot updates

---


## August 9, 2022
20:00 UTC (1:00 PM PDT on 2022-08-09; 8:00 AM NZST on 2022-08-10)

recording: https://zoom.us/rec/share/x3XXpHv91ZwO9w2bpjXLSMWdFlUegkknq_98g7kpOOlfR3q6FWUyyvWdrJxwSg27.hPrVbHafYMnDmJjf

### Attendance

* Nate W. (CNCF)
* Jay Tihema (ii)
* Natali Vlatko (Wayfair)
* Josh Berkus (Red Hat)
* Hippie Hacker (ii)
* Riaan Kleinhans (ii)

### Agenda
* Introductions/Whanaungatanga
* Term 3 accepting project proposals! (Not many projects proposed yet for [CNCF LFX Mentoring 2022 term 3-Sept-Nov](https://github.com/cncf/mentoring/tree/main/lfx-mentorship/2022/03-Sept-Nov))
  * related tweets:
    * https://twitter.com/CloudNativeFdn/status/1555227042345533440
    * https://twitter.com/CloudNativeFdn/status/1557015611385036803
    * unofficial extension to encourage more proposal submissions
* Nate W. on vacation Aug 15 - Aug 26, then travelling Aug 29 - Sept 2. 
    * Will not be present at next WG meeting
  * May need help with email notification coverage for LFX term 3. 
  * Uche Obasi now on-board to assist w/ data entry and processes regarding new applications, to introduce Jay as well
  * LFX Programme platform - built to manage at LF level, set-up so there could only be one admin account which limited ability to support w/ data entry. 
  * New system set-up so a group can work on it instead
  * Admin will enter all descriptions in; copy-paste in system as Owner of project, add Mentors, once programme is opened people can apply.
* Past mentee/mentor engagement 
    * Uche caught up with Jay
    * Proposed graduate program for mentees
    * Increasing the engagement
    * Monthly meetups or other social between mentees
    * Also for mentors
    * Mentor survey?
      * https://hackmd.io/@tag-cs-mentoring-wg/2022-previous-mentor-survey/edit
* Target cohorts moving forward
  * Diversity in mentees - can we get historical data?
  * Diversity in mentors - can we have more than just maintainers, possibly a shadow system?
    * NV: projects have also kept diversity in mind in their own selection process
* LFX promotion NZ
    * NZ Career Expo August 12-13
* Call to action for tommorrow's CNCF Webinar
  * Best link to share for LFX term 3 Sept-Nov: https://github.com/cncf/mentoring/tree/main/lfx-mentorship/2022/03-Sept-Nov
    * This page should be updated with info on how to apply
    * https://github.com/cncf/mentoring/issues/684
* CNCF Students group?
* [x] Update meeting info to use the TAG CS zoom link (auto set to record) [Nate W. & Josh B.]
  * [NW] New zoom link added to calendar and noted above.

---

# Meeting Template

## August 9, 2022
20:00 UTC (1:00 PM PDT on 2022-08-09; 8:00 AM NZST on 2022-08-10)

### Attendance

* 

### Updates/reminders

* 

### Agenda

* 

# Archive

* [June 30, July 12, July 26, 2022](https://docs.google.com/document/d/1ZVFf_GRB5yrcTQieudtk3W-gWL6KuwHn1QG8XKdrARo/edit?usp=sharing)