---
title: TAGCS Mentoring Working Group Monthly Meeting (2023)
tags: Meeting Minutes, 2023
---

[![hackmd-github-sync-badge](https://hackmd.io/7vA7fKNrRG6KrGbA01oupw/badge)](https://hackmd.io/7vA7fKNrRG6KrGbA01oupw)


CNCF TAG Contributor Strategy
# Mentoring Working Group


## About TAGCS Mentorship Working Group

* [Primary repository](https://github.com/cncf/mentoring)
* CNCF Slack: [#tag-contributor-strategy](https://cloud-native.slack.com/archives/CT6CWS1JN)
* [Discussion boards](https://github.com/cncf/mentoring/discussions)
* [Email list](https://lists.cncf.io/g/tag-cs-mentoring-wg/)


## Meeting details

### Recurring monthly
* 2nd Tuesday of the month at 9PM UTC

[CNCF Public Events - TAG CS Mentoring WG](https://tockify.com/cncf.public.events/monthly?search=CNCF%20TAG%20Contributor%20Strategy%20Mentoring%20WG)

### Zoom

Zoom Meeting  
https://zoom.us/my/cncftagcontributorstrategy?pwd=TnI0WU9Eb2I1RlRWdkl1R0k1WkZXUT09

Passcode: 77777


# Past Meetings

## December 12, 2023

21:00 UTC (1:00 PM PDT on 2023-12-12; 9:00 AM NZST on 2023-12-13)

### Attendance

* Nate W.
* Riaan K.
* Josh B.

### Updates/reminders

* Diane & Nate did a talk at Open Source Summit Japan (2023): [The Mentoring Effect: Measuring Effectivenes of LFX Mentoring Programs](https://www.youtube.com/watch?v=bcOowyAxfxc) 

### Agenda

* LFX 2023 Term 3 (mostly) complete: https://github.com/cncf/mentoring/issues/1053
    * Still need to post a blog entry
    * Still need to plan LFX 2024 Term 3
    * Mentor gift sent out :)
* [LFX 2024 Term 1](https://github.com/cncf/mentoring/issues/1077) starting early in the new year ([CFP starts Jan 8](https://github.com/cncf/mentoring/tree/main/programs/lfx-mentorship/2024/01-Mar-May))
    * NW would like to start doing a Mentor zoom meeting before the term to set expectations
* LFX Mentee Summit usually happens early in January - Nate to put Shellea & Ali in touch with Shuah to help
* Availability note: Nate will be away on vacation from Dec 15 to Jan 14.


## November 21, 2023 (postponed from November 14, 2023)

21:00 UTC (1:00 PM PDT on 2023-11-21; 9:00 AM NZST on 2023-11-22)

### Attendance

* Nate W.
* Abby Crimlis
* Jay Tihema
* Ali Ok
* Riaan

### Agenda

* [New Mentoring WG chair](https://github.com/cncf/tag-contributor-strategy/pull/554)
* KubeCon NA 2023 debrief
* Update org-admins guides 
    * [NW] After attending GSoC mentor summit, KubeCon, and noting some issues we had in term 3, I'd like to suggest we create an org guide specifically for the LFX mentorship program, like we have for [GSoC](https://github.com/cncf/mentoring/blob/main/mentoring-wg/gsoc-org-admin-guide.md). We may be able to base it off of the umbrella issues we have (https://github.com/cncf/mentoring/issues/1077), but I think there is more to it than just that (and maybe the umbrella issue becomes a template)
* End of LFX 2023 Term 3 coming up
    * NW to open evaluation form, send mentors link. Evaluations due: Nov 22, last day of term: Nov 30
    * [NW] Several projects have requested extensions, I've approved Nov 29 as their new date for evals
* [Archive GSoD program](https://github.com/cncf/mentoring/issues/1098)
  * issue: https://github.com/cncf/mentoring/issues/1027
  * PR: https://github.com/cncf/mentoring/pull/1099
* LFX Virtual Mentorship Showcase 2024

### Notes

* Rotation of chairs/responsibilities
  * Maybe 18 months
  * Related https://github.com/cncf/tag-contributor-strategy/issues/541
  * Seek/create clarity around similar roles and responsibilies e.g. members, facilitators etc.
    * Project in coming months - efforts w/ LFX, GSOC; create an org admin guide in response to mentors dropping out to date
    * 'Impress upon folx' about the nature of mentoring - although voluntary, still critical to demonstrate commitment to uphold the overall success of the program and relationships
        * Factor investment of time, energy, resources etc.
        * Mentoring info session - outlining expectations, understanding the program etc.
        * Mentees to create blog posts (weekly in other programs) to help program administration
          * google doc?
          * google form checkin?
        * Greater involvement/oversight needed e.g. monitoring Github activity to identify potential sticking points
        * (Mentors) - response to consistently late submissions; work together to create contingency plans to ensure timely submission
        * Remind folx of benefits to companies as well
  * Mentor guide may be useful here too
* GSoC 24 starting - let's setup everything in January
  

## October 10, 2023

21:00 UTC (2:00 PM PDT on 2023-10-10; 10:00 AM NZST on 2023-10-11)

### Attendance

* Nate W.
* Ali Ok
* Diane Mueller
* Riaan Kleinhans

### Agenda

* [Planning LFX 2024 Term 02: Jun-Aug](https://github.com/cncf/mentoring/pull/1094) 
* Google Mentor Summit
* Diane & Nate speaking at LF Member Summit 
* Mentorship content in website: [issue](https://github.com/cncf/tag-contributor-strategy/issues/539)

### Notes

* GSOC Mentor Summit: Nate, see if GSoC has a site like LFX listing info about the program
  * what are Google's plans for publishing project/mentee data after a cohort is completed
  * https://summerofcode.withgoogle.com/
  * https://summerofcode.withgoogle.com/organizations/cncf/projects 
  * is there a listing? helpnig mentees share that they have been a participant
  * Perhaps: https://summerofcode.withgoogle.com/programs/2022/projects
  * Perghaps: https://summerofcode.withgoogle.com/programs/2022/organizations/cncf 

## Sept 12, 2023

21:00 UTC (2:00 PM PDT on 2023-09-12; 10:00 AM NZST on 2023-09-13)
Link to recording: https://www.youtube.com/watch?v=d1w7UmZFyic
### Attendance

* Diane Mueller (Bitergia)
* Nate W. (CNCF)
* Ali Ok (Red Hat)
* Daniel Krook (CNCF)
* Riaan Kleinhans (ii)

### Agenda

* Mentoring Effect research update - Nate W. & Diane M.
* [Riaan] Ashutosh Kumar (ashutoshak5386) offered to work on issue [Update "Full List FAQs" for Mentees #1022](https://github.com/cncf/mentoring/issues/1022)
* [Grace Hopper Celebration 2023](https://ghc.anitab.org/) - Nate W. Attending, will be working the CNCF booth with an eye to Mentorship programs.
    *  I have given some guidance in the issue and invited him to the meeting.
* Plan LFX mentorship program 2024 Term 1: Mar-May (https://github.com/cncf/mentoring/issues/1070)
* Number of mentors suggestion for LFX and GSoC (https://github.com/cncf/mentoring/pull/1081#discussion_r1322633005)
    * Action items:
        * Ask Google if we can tell mentors that we need a co-mentor
        * Change the org admin rules to tell mentors about being reachable and the deadlines during proposal approval


## August 8, 2023

21:00 UTC (2:00 PM PDT on 2023-08-08; 10:00 AM NZST on 2023-08-09)

### Attendance

* Ali Ok
* Josh Berkus
* Riaan Kleinhans
* Corey Leong
* Jay Tihema

### Updates/reminders

* [Term 02 of LFX Mentorship](https://github.com/cncf/mentoring/tree/main/programs/lfx-mentorship/2023/02-Jun-Aug) is approaching to an end
  * Final mentee evaluations due August 23 
* [Term 03 of LFX Mentorship](https://github.com/cncf/mentoring/tree/main/programs/lfx-mentorship/2023/03-Sep-Nov) is starting soon
  * 36 project proposals, 17 projects represented, 47 mentors
  * We're in mentee application period (August 2 - 15)
* GSoC 2023 is almost finished
    * August 21 - 28 is the final week - [timeline](https://developers.google.com/open-source/gsoc/timeline)

### Agenda

* [Corey] Mentorship opportunities for the university students
* Project board grooming - ([board1](https://github.com/orgs/cncf/projects/25/views/6)) ([board2](https://github.com/orgs/cncf/projects/25/views/9))
* [Jay] Updates TBA

### Notes

* [Higher Ed initiative](https://github.com/cncf/tag-contributor-strategy/issues/460)
* [GSoC @ CNCF](https://github.com/cncf/mentoring/tree/main/programs/summerofcode)
* [LFX Mentorship @CNCF](https://github.com/cncf/mentoring/tree/main/programs/lfx-mentorship)
* [Guide - Getting started to Open Source](https://contribute.cncf.io/contributors/getting-started/)
* [#tag-contributor-strategy](https://cloud-native.slack.com/archives/CT6CWS1JN)


## July 11, 2023

21:00 UTC (2:00 PM PDT on 2023-07-11; 10:00 AM NZST on 2023-07-12)

### Attendance

* Nate W.
* Josh Berkus
* Riaan Kleinhans
* Catherine Paganini
* Diane Mueller
* Jay Tihema
* Paris Pittman
* Rohan Dahibhate

### Agenda

* Riaan - [Project board](https://github.com/orgs/cncf/projects/25/views/1) grooming
    * Workflows have been created to auto-add issues and PRs to the “New” Column  - Thanks Nate for pointing out the way!
    - For managing the project board we need some time in every meeting to triage and groom tickets in the “New” column. 
        - First task is to evaluate the 8 Mentor WG issues currently in “New” for being valid or stale.
        - If an issue is valid, let's move it to “Backlog” or another appropriate column.
        - If it is stale, let’s close it.
    - Let’s try and label all issues, so the board filters work
    - Some explanations about the columns have been added at the top of each column. Please let me know if changes to the columns or descriptions are needed. 
* Program updates
    * **LFX** - Term 2 Midterm evals due tomorrow (July 12, 2023)
    * **GSoC** - Midterm evals due July 14 (for most projects, one has extended and will have different dates)
    * **Deaf/hoh**: 
        * Updated [issue](https://github.com/cncf/tag-contributor-strategy/issues/421) with audience, mission, goals
        * Scheduled first official meeting (with ALS interpreter, captions, gallery view recording)on the 4th Tuesday of each month at 5pm ET
        * Focus: recruit more deaf/hoh members
            * Kickstarted social media campaign
                * Two new members joined after seeing the social media posts
                * [LinkedIn](https://www.linkedin.com/posts/iansmith13_cloud-community-deaf-activity-7084214874095943680-iU_7/)
                * [Twitter](https://twitter.com/metaforgotten/status/1678446702825721856)
                * [Mastodon](https://mastodon.social/@Deafveloper/110690520567866407) 
        * One deaf/hoh member to attend KubeCon (first time ever!)
        * CNCF encouraged deaf/hoh to apply for scholarships
            * Provided feedback on gaps in scholarship and registration form
* Mentorship statistics & reporting - Nate, Diane, Josh & Dawn
    * New position proposal: Mentoring WG Tech Lead
        * Nomination: Diane Mueller 
        * Nate W. suggests that we invite Diane Mueller to participate officially as a Tech Lead so that we can provide access to internal docs that would normally be private in order to facillitate statistics research & reporting around our programs.
    * process question - this discussion is a start, but do we need to add something to cncf/mentoring, or cncf/tag-contributor-strategy?
* NZ Updates
    * KCD Sydney
    * Shadowtech, Canvas events
    * Training & Certs
* [Paris] Program documentation for mentoring initiatives that are not 1:1 and/or focused on growing contributors that are already there into maintainer roles 
    * maintainer circle
    * documentation / templates / etc
* Sickness policy
    * what happens if someone falls ill and is unable to complete their menteeship duties (mentees or mentors both)

### Notes
(Riaan) 
* Project board - workplace created, new columns with all open issues collated - label as needed
    * Busy closing issues; seeking consensus for closure
    * Slack discussion reference >

(Nate)
* LFX progressing well - mid-terms due tomorrow
    * Seeking advice on policy around illness and how this affects mentees' ability to complete program
* GSOC evals recenty opened, 1/3 submissions received

(Catherine)
* DHH - issue update w/ audience goals
* 1st official meeting - CNCF providing ASL interpreter to support recording 
* Focused on recruiting more DHH; ideally to be driven by the community themselves
* 2 new members have joined, 1 new attendee for Kubecon NA; Chris A has also encouraged new scholarship applicants - has highlighted gaps in application forms/processes esp. re disability and associated factors

(Nate/Diane)
* Potential Tech Lead role in Mentoring WG for Diane - stats, recording etc would provide ability to access Google Drive, relevant resources
    * Creating dashboards for tracking mentorship comms, progress, reflections etc. 
    * Focus on both mentees and mentors
    * Aim to share findings at monthly meetings to help drive potential improvements in ongoing efforts

(Paris)
* Efforts to grow contributor base, managing engagement at scale; ideally  beyond 1:1s
* Current WG streams accommodate 'many-to-1' mentoring models primarily - open to discussing other programs and methods 
* Focus to date has been entry-level programs, historically haven't had sufficient help to look further
    * Explore scope for CNCF to support with a sign-up tool
    * Reviewer cohorts, shadow programs, buddy systems, AMAs
    * Open issue/discussion to promote the opportunity; seeking assistance

(Nate)
* Sickness policy - will be determined by duration of illness; in some cases partial payment has been issued to mentees
    * LFX has more flexibility than GSOC by comparison; may be able to manage on case-by-case basis
    * Can be difficult with no means of verifying illness status; to consider
    * https://docs.linuxfoundation.org/lfx/mentorship


## June 13, 2023

21:00 UTC (2:00 PM PDT on 2023-06-13; 10:00 AM NZST on 2023-06-14)

### Attendance

* Nate W.
* Catherine Paganini
* Riaan Kleinhans
* Ali Ok
* Josh Berkus
* Jay Tihema

### Agenda

* [Meeting cadence](https://github.com/cncf/mentoring/issues/1015)
* [Is GSoD a good fit for the Mentoring WG?](https://github.com/cncf/mentoring/issues/1011)
* GSoC mentor summit
    * NW planning to attend
    * Discussion: https://github.com/cncf/mentoring/discussions/848#discussioncomment-6149827 
* (aliok) [Mentor guide](https://docs.google.com/document/u/1/d/1Zozg3g5qE4jkdVEdiVtCoXvc_iuuOls1hfCgW6Pf7jQ/edit?usp=sharing) - good enough to create a PR?
* Update on the [DHH initiative](https://github.com/cncf/tag-contributor-strategy/issues/421) 
    * Met with Gallaudet professor
        * IT department not super deep
        * Schedule a talk to get a sense of interest
    * #dhh-in-cloud-native channel
    * [4 volunteers](https://docs.google.com/document/d/18OMOIhTYSa0v6dVi9u6WMQq25dpy3fc0kxjjzE_gzEk/edit#) (two DHH, one hearing and fluent in ASL)
* Update on NZ efforts

### Notes

* **Cadence** - Proposal to reduce to frequency to one-monthly meetings - special topics meetings vs. general updates 
    * Need to review/revise our goals in terms of progress and performance. 
    * Initial goals of obtaining more help w/ community support, working towards mentee numbers objective tracking wells
        * Nate to add calendar note to reflect change
* *To do: Fix calendar note for meeting link*
* **GSOD fit** - may not be the right fit for  Mentoring WG objectives
    * (Issue opened to discuss further if needed)
    * Previously coordinated through Tech Docs dept.- if not through WG; may not be worth tracking through CNCF esp. if low Cloud Native project submissions
    * Tracking - informing community of cycles; application dates, assistance, relevant comms
    * Doesn't match the key description of focus mentoring programs e.g. LFX - what is needed for inclusion in CNCF mentorship/initiatives
    * Consensus to remove from workstream
* **GSOC Mentor Summit**
    * Will fund one org person and mentor to attend (incentivised); one expression of interest so far
    * Limited space available only
    * Notify mentors list for feedback on next actions
    * > Many orgs want to send more than one delegate to the Mentor Summit. If your organization has more than one delegate that wishes to attend the Mentor Summit, please have them put their name on the waitlist.
* (Ali) **Mentor Guide**
    * Google doc created; please review and add comments/feedback
    * Will allow review time then create a PR
        * Open PR to link to doc for view
* (Catherine) **DHH initiative**
    * Connected w/ IT dept in Gallaudet Uni; met w/ professor to discuss
    * Primarily liberal arts college; expressed interest in collaboration - proposed talk to students about cloud native
    * 4 volunteers to support effort; deaf or have family that are, high initial engagement
    * Need to keep working w/ deaf community to determine key considerations as things progress
    * How can Mentoring WG/community best support? Plan > role of TAG > decide actions to implement etc. 
    * Identified professor who might develop an open source curriculum; current skillset doesn't exist in Gallaudet
    * Will find the right place for it to sit if not in Mentoring e.g. TAG C-S
        * Review possibility of all CNCF calls etc. use close-captioning etc. to support communication/participation
* **Kubecon NA**
    * Any CFPs for talks? e.g:
        * Getting Started guide
        * Ali at KCD Istanbul
        * Nothing at TAG level yet
        * Talk in sign language


## May 23, 2023

21:00 UTC (2:00 PM PDT on 2023-05-09; 10:00 AM NZST on 2023-05-10)

### Attendance

* Nate W.
* Ali Ok
* Riaan Kleinhans
* Jay T
* Brad McCoy

### Agenda
* [Nate W.] working with LF to get some support for LFX mentoring platform
    * LFX Platform admin access for non-CNCF-employees?
* [Riaan] From the last CNCF TAG Contributor Strategy Meeting’s ROADMAP topic I have created the [TAG Contributor Strategy Project Board](https://github.com/orgs/cncf/projects/25/views/1) with a specific view for [Mentoring WG](https://github.com/orgs/cncf/projects/25/views/6).
    * This give an overview of all issues and PR’s marked with the Mentoring label
    * Status is controlled on the main “Project Board view”
    * I added 2 issues from the https://github.com/cncf/mentoring/issues repo. For the issue to show up on the "Mentoring view" I had to create the "Mentor label"
    * Is this the way we want to go?
        * If yes, I will add the rest of the mentoring repo's issues & PRs to the board (and also add the "Mentor" label to each)
    * > [name=Ali Ok] I can't see the boards, are they public?
        * It is set to Private - do not have owners rights. Will get someone to change that.
* LFX '23 Term 1
    * End of semester evaluations due May 24, 5:00 PM PST
    * Final day of semester: May 31
        * There has been several questions about why the end of semester and when the evals are due are on different dates
* LFX '23 Term 2
    * Applicications due today
    * Mentor email list created - at 5:01 PM PDT an email is scheduled for selections. Selections are due Mon May 29, 5:00 PM PDT
* (Ali) GSoC - coding starts next week!
  * Should we reach out to mentors asking 
    * if they reached out to their mentees
    * if there are any inactive mentees (28 May is the deadline for informing Google about this)
* (Ali) _Underground_ mentoring program video - Kube release team orientation: https://www.youtube.com/watch?v=5ZYrgQrOeHA
* maintainers cirle
    * Nate & Lee - Tue May 30 @ 9:00 am PDT
* stipends process update
* Move / surface program statistics to the top level
    * [Resurface program statistics #1000](https://github.com/cncf/mentoring/issues/1000)

### Notes
* Be mindful in reviewing/approving PR requests - dates were overlooked in the latest LFX intake and the end date clashed with the new intake. No single person accountable but critical for future actions
* Nate working to get support from Linux Foundation (met w/ John recently) - seeking help w/ LFX platform admin. 
    * Most exists in Google etc. and becomes time-consuming transferring to the platform. Ali actively supporting in the meantime. 
* (Riaan) Project boards are currently private; need to be made public. Prev. raised to create a central TAG C-S board to review ongoing workstreams; immediate focus on Mentoring efforts.
    * Nate will action to make boards public
    * (Nate) This board should be able to be linked to the Mentoring Repo; remove Mentoring label for ease of use/actioning. Consider reviewing alternative methods of tracking for simplicity across various mentoring-related issues.
    * Nate to seek Admin status for the board to connect to Repo. Riaan has introduced all issues manually to date; can be optimised. 
    * (Ali) Decide/clarify intended purpose for the project board overall. Consider enforcing labels to help keep track of issues that remain unresolved and may generate from multiple sources etc. 
* LFX - end of semester evals due. Mentees work should be completed day before evals are due; impacting evaluations otherwise - should be explicit about these expectations. 
* Should greater emphasis be placed on mentee blogs in last week of LFX? Would need to add to documentation if so. 
    * Benefits/considerations:
        * Offer training or swag to incentivise
        * Helps to identify areas for improvement
        * Supports current and future mentees/mentors
        * Would create more work for admins to review blogs etc.(esp. if 30-60+!) - capacity dependent
* LFX Term 2 applications due today. 
* GSOC coding starts next week 29/5 - should contact mentors to identify inactive mentees to notify Google asap so as not to prolong failures etc. Due date Sun 28/5.
* (Brad) Sharing under-grad mentoring program vid - shadow orientation for K8s mentoring program. 2 other projects adopting it including Cluster API. 
* (Nate) Lee Calcote, Dave Sudia working on Maintainer Circle - Nate to intro WG, overview of programs and impact/successes, how CNCF supports access to programs, encourage others to contribute etc. (1hr pres). 
* (Nate) LFX stipends process 57/60 mentees approved to be paid. Prev. approval system inefficient; working internally to seek help in improving, WIP.
* (Nate) - Chris A couldn't find program stats page and requested 'unburying' this for easier access. Need to relocate as top-level information; at least most-recent stats. 
    * Expected this will help raise awareness + uptake of programs
    * Should we consider a Mentoring website alongside the Repo? Currently in Q3 so timing might not be optimal.
        * Need to build out current Repo content beforehand
        * Markdown content can be embedded easily
        * If content on site; shouldn't be 'loose' in the Repo
        * Purpose of website? Highlighting programs etc. 
        * Repo copy etc. 2-3-fold audience/stakeholders: 
            * CNCF, TAG, Governing Board
            * Mentees seeking program info
            * Mentors needing to understand specifics for those eligible. 
* (Riaan) Re-locating program stats to front page without mess e.g. disclaimer paragraph to provide context on decision for placement vs. physically moving the page etc. 
    * Consider adding most recent stats only to reduce/manage 'noise' vs. complete archives
    * Nate working w/ Dawn & Josh to see whether people have contributed since end of mentorships.
    * Nate proposes continuing this decision in the relevant Issue - consider what will be least demand on work 


## May 9, 2023

21:00 UTC (2:00 PM PDT on 2023-05-09; 10:00 AM NZST on 2023-05-10)

### Attendance

* Ali Ok
* Josh Berkus
* Jay Tihema
* Riaan Kleinhans

### Agenda

* [aliok] GSoC selection and ranking is done - Google's deadline is April 27
* [aliok] GSoD - 2 out of 13 accepted proposals is from CNCF - [announcement](https://github.com/cncf/mentoring/discussions/843#discussioncomment-5492931)
* [aliok] LFX Mentorship date shift (?)
    * https://github.com/cncf/mentoring/pull/943
* [aliok] contribute.cncf.io website updates
  * Now mentions Mentoring WG - [link](https://contribute.cncf.io/about/working-groups/)
  * Main "I want to be a contributor" page is now up-to-date with simpler instructions - [link](https://contribute.cncf.io/contributors/)
* [Jay] Explore alignment/overlap w/ CNCF Students (Kunal), repo content
    * Collaborate & coordinate, but two seperate groups
        * Like: LFX, we handle the mentors, they work with the students
        * Also they want to do some things out of our scope (e.g. Campus Ambassadors)
* [Jay] Establishing/coordinating Peer Mentoring Group (?) or similar initiatives (see notes for reference)


### Notes

* LFX PRs open - Nate to create in platform; offered support - might be limited to CNCF admins only
* Kunal alignment w/ TAG.C-S - to review

**What are the main goals of this WG and what do we see as barriers to achieving them?**
•	Build sustainable growth of existing mentoring programs
•	Support the pipeline/ladder from Contributor/Mentee > Mentor/Maintainer

**What do we see as the key actions/opportunities we could take to achieve them?**
•	Supporting/integrating existing or proposed initiatives
•	Improving onboarding and navigation documentation 
What are the main considerations we’d need to have moving forward?

**What is most conducive to the WG and its ability to contribute?**
•	Time commitment, compatibility, structure, guidance, coordination etc.
•	Avoiding replication of existing efforts

* Retention is an ongoing issue, expected to be low with given target audience
* Mentoring program towards professionals - wouldn't mean being part of a paid program for instance
* DO we fill all slots applying for programs? (Mentees)
* Ability to track pathways post-programme completion
* Many career-changers or newcomers; lots of experimenters to determine whether or not they want to stick around
* Want to set efforts with different target audiences
* Mentoring ppl who are regulare contributors into Reviewes (group mentoring, common)
    * Would need help in setting up a structure and operating - expect a high retention rate from this
* Front-end engagement prioritised? Managing new and professional (preferred for mentors) mentees - what systems/processes can best support this? Same 'pre-work' needed
* *System to collect project proposals for communities, independent of any mentorship programme?*
* 'Rejekts' idea; might be left to communities to manage those who aren't initially accepted to established programs
* Documentation on advising next/backup steps for unsuccessful applicants 



[Jay] *Current active/proposed mentoring or pathway initiatives for review/consideration*

***Supporting Maintainers/Developing Mentors***

* '**Buddy System**' (leonardpahlke) - 1:1 peer matching, anticipated issues with time commitment, compatibility and impact 
* '**Maintainers Circle** *(Paris)* **'How to build shadow programs'** Guidance on how to create roles, identify roles, etc.
* '**Group Mentoring Programs**' *(Paris)* - Structured, time-bound format towards key goals 
https://github.com/cncf/tag-contributor-strategy/issues/393
* '**Shadow Mentoring**' (*Hippie*)  - Operationalizing mentoring/shadowing programs that exist in K8S SIG Docs, etc.
https://github.com/cncf/mentoring/issues/950

***Supporting Newcomers***
* **'CNCF newcomer buddy groups'** (*xinity*) - Linking newbies to potential mentors
https://github.com/cncf/tag-contributor-strategy/issues/393
* **'Student Pipeline'***(Kaiwalya)* - proposal in development https://docs.google.com/document/d/1oIBJmhIYDHkDYYzi8PCD8JuUMHqGNTTNtTRXIPkeQMs/edit?usp=sharing
* **'Pathways for disabled communities**' *(Catherine, TAG)* - in discussion
* **CNCF Students** *(Kunal)* - (full link needed,including repo) https://community.cncf.io/cloud-native-students/

---

## April 25, 2023 (Cancelled due to no attendance)

21:00 UTC (2:00 PM PDT on 2023-04-25; 10:00 AM NZST on 2023-04-26)

### Attendance

* (Cancelled: no attendance)

### Agenda

* [aliok] GSoC selection and ranking is done - Google's deadline is April 27
* [aliok] GSoD - 2 out of 13 accepted proposals is from CNCF - [announcement](https://github.com/cncf/mentoring/discussions/843#discussioncomment-5492931)
* [aliok] LFX Mentorship date shift (?)
    * https://github.com/cncf/mentoring/pull/943
* [aliok] contribute.cncf.io website updates
  * Now mentions Mentoring WG - [link](https://contribute.cncf.io/about/working-groups/)
  * Main "I want to be a contributor" page is now up-to-date with simpler instructions - [link](https://contribute.cncf.io/contributors/)


## April 11, 2023

21:00 UTC (2:00 PM PDT on 2023-01-11; 10:00 AM NZST on 2023-01-12)  
**Note**: this meeting may be cancelled or postponed due to its proximity to KubeCon EU.

### Attendance

* Riaan Kleinhans
* Josh Berkus
* Nate W. (briefly) 

More of a conversation than a meeting, should not be posted to Youtube.

### Updates/reminders

* Nate W. availability updates:
  * travelling for KubeCon EU April 13-21, 2023
  * vacation April 24-28, 2023 (Note, Nate can be available during this time as there is a GSoC deadline this week)
      * Move out to 5 May 2023

### Agenda

* LFX Term 02-Jun-Aug
    * We should draft an email to open the next term of LFX: https://github.com/cncf/mentoring/tree/main/lfx-mentorship/2023/02-Jun-Aug
        * issue: https://github.com/cncf/mentoring/issues/926
        * Should note that any GSoC projects that aren't accepted would be a great project for LFX term 02
        * previous email: https://lists.cncf.io/g/tag-cs-mentoring-wg/message/7
            * should send to: tag-cs-mentoring, toc list, add to Maintainer newsletter, cncf/mentoring discussions board, #mentoring slack
    * Should we push the deadline for project ideas back a week? - Move out to 5 May 2023
    * Should we create a templates folder in the cncf/mentoring repo for common communications like this?
        * Yes, that make sense
        * Make sure we do not forget any info
        * Let's make templates and review as a group
* LFX Term 01-Mar-May
    * Currently going through evaluations, evals due Wednesday Apr 12 @ 5:00pm pacific time
* GSoC
    * Currenly assessing contriubtor proposals
    * details & dates: https://github.com/cncf/mentoring/discussions/918#discussioncomment-5548149 
* Mentoring repo refactor:
    * https://github.com/cncf/mentoring/pull/927 - update to call out draft pages
    * https://github.com/cncf/mentoring/pull/899
    * Happy day!! It is merged!! :tada: 


## March 28, 2023

21:00 UTC (2:00 PM PDT on 2023-01-28; 10:00 AM NZST on 2023-01-29)

### Attendance

* Nate W.
* Jay Tihema
* Ali Ok
* Riaan Kleinhans

### Agenda

* Nate W. goofed a sync merge, and accidentally merged it into `main` rather than `v2`
    * Mistake was reverted
    * Some history seems to have been lost
    * Need to recrate the v2 PR as the original one was closed in the mistake
    * Some issues tied to PR 773 have been closed as part of the "fixes:" automation
    * **Lessons learned:**
        1. Don't do complex (or even simple) merges on important projects when you're tired or otherwise disctracted
        2. Don't bypass security measures put in place to protect the `main` branch -- especally when doing 1. above
        3. The revert function works suprisingly well, but seems to have stripped out some of the history. Revert doesn't undo closed issues or PRs.
        4. Don't be afraid of making changes or mistakes because there's very little that can't be undone (though, don't be afraid to ask for help if you get git in over your head)
* **Walk through of cncf/mentoring v2 repo update**
  - https://github.com/cncf/mentoring/pull/733 - closed accidentally. Nate to open new one.
  - **New tracking PR**: https://github.com/cncf/mentoring/pull/899
  - Riaan & Jay
* **KubeCon**
    * TAG Contributor Strategy: What We Get Out of It (and You Could Too!)  
      Date and time: Thursday April 20, 2023 15:25 - 16:00 CEST  
      Room: Auditorium Center | G109  
      https://sched.co/1HzdC
    * Mentorship Office Hours
      Date and Time:  Wed, 19 April, 14:30 - 16:30  
      Room: E101  
      Seating: Boardroom 16pax  
      https://sched.co/1KWw8
    * Tech Docs Office Hours (if you're interested 🙂)  
      Date and Time:  Thur, 20 April, 11:00 - 12:30  
      Room: E101  
      Seating: Boardroom 16pax  
      https://sched.co/1KWw2
* **When is the good time to merge v2?**

### Notes
**V2 merge accident**
* Set of GitHub actions hacks that can provide some functions of PROW - Rob Kielty has done some work on these and might offer some solutions to avoid recurring/similar issues
* Can be helpful to let people know these kind of mistakes are ok and can happen - and important they know they can seek help/support when needed to navigate the space

**Walk through of cncf/mentoring v2 repo update**
* Updated V2 repo, initial changes made, Riaan/Nate made additional updates in mentee/mentor section. 
* New PR #899 - (initial changes shown)
* Main branch currently shows multiple scattered files and info. V2 is a rearrangement of pre-existing information to be more accessible for various user types
* Have created new content sitting under Mentee or Mentor-specific ReadMes with a more logical flow and consistent layout across both sections
* Will need to be set up so things are obvious and organised in their flow moving forward; also factoring other points such as *'How to be a mentor in GSOC'* etc.
* Project Board - mentoring issues, public calendar and CoC to be addressed
* *Will need to double-check Nate's PR cleanup to ensure things are set out as needed*
* May be some broken links from outside, but can be detected internally e.g. Google Analytics(?) or other automated systems, but possibly not high-priority at this stage
* Working on this Repo can likely be a recommended 'Good First Issue' for new Contributors
* Shouldn't need TOC approval with it not being website content, but TAG review would be appreciated with lots of changes having been made
* Can possibly look at integrating mentee/mentor/program info into Contributor.io eventually
* *Josh will review w/ Carolyn before approval*

**KubeCon**
* *TAG Contributor Strategy: What We Get Out of It (and You Could Too!)* - panel discussion 
* *Mentorship Office Hours* - room booked for a couple of hours to chat w/ maintainers on how to write proposals; first come, first served
    * More in attendance, the better (Weds 2.30pm-4.30pm)
* *Tech Docs Office Hours*

Join us at times listed!

**When is the good time to merge v2?**
* Would like to merge sooner than later; mindful of upcoming Kubecon. GSOC deadlines few weeks away so timing is good
* Would be ideal to have set up before KC EU


## March 14, 2023

21:00 UTC (2:00 PM PDT on 2023-03-14; 10:00 AM NZST on 2023-03-15)

### Attendance
* Nate W.
* Riaan Kleinhans
* Hippie Hacker
* Justin Vice
* Alexandre Nicastro
* Josh Berkus

### Agenda

* All comments have been addessed in [start contributing to open source
#339](https://github.com/cncf/tag-contributor-strategy/pull/339)
    - Should we merge it?
    - Clotributor question
    - Nate to put Riaan in touch with CNCF blog team
    - NATE: YouTube Series : Getting Started
      - process, downloading, finding issues
      - how to contribute to Open Source
      - Maybe Ambassador?
* GSoD PRs in today -- could use some help reviewing
    - https://github.com/cncf/mentoring/pull/877
    - https://github.com/cncf/mentoring/pull/875 
    - Org applicaitons due March 24, 2023 at 18:00 UTC
* GSoC
    - Admin guide PR: https://github.com/cncf/mentoring/pull/871
    - March 20th, mentors can start giving feedback at that time
    - Mentors are already in the system
* simple coder templates
  - https://github.com/cncf-infra/coder-templates/tree/main/simple
  - https://github.com/cncf-infra/coder-templates/tree/main/simple-packet
  - https://github.com/ii/emacs-coder/blob/master/templates/emacs-pod/main.tf
* Tauranga Kids Day March 31st
  - https://github.com/orgs/workshop-coop/projects/3
* KubeCon EU Kids Day April 15th
  - https://github.com/orgs/workshop-coop/projects/1
  - workshop.coop hosted coder instance with templates for littil.org KubeCon Kids Day.
  - https://hackmd.io/rHr0DSGpRnmlGzI1p-WzWw
* KubeCon mentoring office hours 
  - 2 hours, time date tbd
  - free form discussion, have a question about CNCF Mentoring, come by and say hi 
* V2 review
  - https://github.com/cncf/mentoring/pull/733

## February 28, 2023

21:00 UTC (1:00 PM PST on 2023-02-28; 10:00 AM NZST on 2023-03-01)

### Attendance

* Nate W.
* Jay Tihema
* Ali Ok
* Riaan Kleinhans
* Josh Berkus
* Alexandre Nicastro
* Parashar Singh

### Agenda

* Adding Ali Ok to GSoC CNCF administration team
* LFX Mentorship Term 1 updates
  * Nate W. would like to accept applicants as mentors make selections, rather than as a batch on Friday/Monday. (This also gives us more opportunity to adjust when mentors make the same selection)
* Project Board/Management  
  https://github.com/orgs/cncf/projects/16/views/1

### Notes

* Ali Ok accepted as GSOC admin, new process in ongoing review, operations/comms will be conducted in open and continue refinement going forward. 
* LFX Term 1 updates - 20% all mentors have made their selections; may have missed deadline notification prior > 7 March. 
    * Suggested acceptance process starts now to reduce admin processes w/ Nate and LFX. Nate will send an email and post to confirm
* Contacts to go to Natali from previous meeting
* Question about GSoD: https://github.com/cncf/mentoring/discussions/843#discussioncomment-5052374
    * Not yet run as an org (Nate); GSOD issue last year - allowed only one project per year previously. **Reach out to Google and clarify/confirm any project submission limitations.**
    * (Previously one project per OS project)
    * > (b) Each Organization may submit one (1) Organization Application. https://developers.google.com/season-of-docs/terms/program-rules
    * Timeline: https://developers.google.com/season-of-docs/docs/timeline
* Alexandre experiencing multiple enquiries regarding getting started in Mentoring
    * (Josh) need clarity about target audiences; persona-based responses 
    * Queries generally broad and inconsistent - general 'guidance'-based questions
    * Resources/guides would need to linked to support navigation; conscious of large workload to inform/build fundamental understanding
    * Potential contributors might be cautious of needing 'permission' of getting involved to begin with
    * This would go at: https://contribute.cncf.io/contributors/
    * Maybe a short video can be recorded (can be asked from CNCF Ambassadors)(example) https://www.youtube.com/watch?v=msyGybzCKRs
    * Potential personas
      * new to open source
      * new to cloud native
      * folks changing careers(?)
        * may not lead to sustained contributions (NW + JB)
        * may be an in to opensource regardless (JT + AN)
        * Ongoing discussion needed; to refer to TAG-CS
        * File an issue, attach to draft doc in HackMD/Google Docs, mention on Slack - pertains to both mentoring and Contributor Growth
      * folks assigned by their company to work on open source
      * AN to open issue: https://github.com/cncf/tag-contributor-strategy/
        * Previous Slack discussion https://cloud-native.slack.com/archives/CT6CWS1JN/p1675715555437939
* 65 projects proposed for LFX, not all proposals have viable candidates at this stage
* GSOC - March 20 potential contributors to propose, expecting comms in boards re upstream issues 

## February 14, 2023

21:00 UTC (1:00 PM PST on 2023-02-14; 10:00 AM NZST on 2023-02-15)

### Attendance
* Nate W 
* Jay Tihema
* Ali Ok
* Alexandre Nicastro
* Natali Vlatko
* Riaan Kleinhans

### Agenda
* Google Season of Docs -- Org applications start tomorrow
  * Next steps?
  * Historically we only get 1-2 slots
* Notification template - informing Mentees of preferred processes > TAG-CS template
  * https://cloud-native.slack.com/archives/CT6CWS1JN/p1675715555437939
* Timeline proposals for LFX Mentorship Terms 2 & 3: https://github.com/cncf/mentoring/pull/833
* LFX promotion on available channels
    * Social boosts for LFX Mentorship Term 1 applciations
      * https://twitter.com/CloudNativeFdn/status/1625192237587111936
      * https://mstdn.ca/@natew/109864484786454672
      * https://www.linkedin.com/feed/update/urn:li:activity:7031335091217809408 
* v2 additions, workload > PRs

### Notes

**GSOD** 
* Applications starting tomorrow. Would like to apply as an org; requires doc project proposals to support application submission.
* Not expected to have as many slots available this year, but would like to proceed regardless. Nate will create PR to set up GSOD.

**Notification template for Mentees**
* Following thread in TAG-CS Slack - response to lots of 'noise' in #mentoring w/ general questions vs. support of upstream issues.
* Msg replies not necessarily helpful in redirecting or addressing issue. Need to create more effective responses e.g. *template as well as support/training to also foster positive engagement and retention.*
* Need multiple fronts to 'teach' the preferred behaviour; in addition to Ambassadors supporting this, having coordinated responses
* Matter of coaching people out of learned behaviours that might not be constructive to attaining opportunities or impacting future relationships; may be less about *contributing* than not even investigating the project to begin with.
* Better to have template 'available', or respond to every such request/query each time - how to best manage overall 'noise'? e.g. responding to multiple instances than every single one.
* https://hackmd.io/W-VB1zZtTnOJFBSWR3frUA (working doc)

**Timeline proposals for LFX mentorships Term 2-3**
* Open for discussion

Social links boost, need support/please share!
* Deadline is 21/2/23

**V2**
* Current layout/format ineffective in guiding mentees/mentors effectively, as well as structuring/archiving program information. 
* User perspective vs. group view on what's needed in this Repo - to help group determine what needs to be updated first e.g. who will be engaging with this resource.
* Can utilise mentees/mentors to review and provide feedback - previous mentees for could be more beneficial (even limited numbers)
  * TODO: Nate to reach out to find folks, Natali to run interviews
* Could potentially request mentees at program completion review the Repo as well. 
* Need to confirm what is needed to produce an MVP ahead of potential merge in the next month
* Contributions - comment PR-level discussions; link any new PRs against V2 to maintain visibility.
* Umbrella PR: https://github.com/cncf/mentoring/pull/733

**CLOTributor**
* Being positioned as preferred 'job boards' to promote opportunities for contributors; recommended to focus here for development.

## January 24, 2023

21:00 UTC (1:00 PM PST on 2023-01-24; 10:00 AM NZST on 2023-01-25)

### Attendance

* Nate W.
* Ali Ok
* Josh 
* Alexandre
* Riaan
* Jay

### Agenda

* LFX Mentorship Project Proposals
  * https://github.com/cncf/mentoring/tree/main/lfx-mentorship/2023/01-Mar-May
* 2023 Goals
  * https://hackmd.io/@tag-cs-mentoring-wg/2023-goals
* Repo revisions
  * project board: https://github.com/orgs/cncf/projects/16/views/1
* GSoC Org applications
  * Nate W. to work with Chris A. to apply as an org
  * https://groups.google.com/d/msgid/google-summer-of-code-discuss/649212c4-fe0d-4cb6-8e48-17f961e3d0ben%40googlegroups.com?utm_medium=email&utm_source=footer

- Ali:
Could we have the [Ideas page](https://github.com/cncf/mentoring/blob/main/summerofcode/2022.md) open earlier? Motivation for the ask is that the potential mentees want to start exploring the project ideas earlier. Similarly, maintainers want to list their ideas earlier for encouraging a head start.

- Options are making the Ideas page availible through out the year
- Incorporate CLOtributor with the process with `Help wanted` & `Mentor Available` labels
    - AI: Riaan & Jay add CLOTributor to the Mentoring repo
- **Could use Git discussions for this as well.** 
    - GSOC 2022 - Nate opened a thread to support this, however only 15% of this thread was used; also creating alot of overhead to maintain. Because this will all link back to upstream issues; preferred this would occur off the boards. 
    - Might also be hard to filter convos back into the issues themselves as well. An ideas page however would give a centralised reference point for those seeking information. 
    - We should keep encouraging mentees to reach out to potential mentors; aiming to give mentors more time to make their selections as well.
    - Having alot of mentees/applicants can be difficult to filter/process effectively otherwise.
    - Another option might be for mentees to 'source' their own mentors to support/drive projects as well > Application Process
        - If a potential mentee is interested in a CNCF project and wants to do a mentorship, this should put the impetus on the mentee themselves; this mechanism currently exists but is not explicitly communicated.
        - This might be an issue especially for paid mentorships such as LFX. This could be exploited from a faculty of an education provider for instance that could implement their own mentee without following the preferred process.  
**How to incorporate Clotributor into the existing onboarding process?** Future working session(s) to determine best course of action.

**Repo update**
- Thank you for review Ali & Nate
- Next step might be to merge in v2 branch
    - Then clean up and distill information in Mentee and Mentor files to a single readme for people to the contribute
    - Try and make the info clear one stop place to find info
    - Might have to hold back on merging in the v2 branch because links have been publish to current repo info.
    - When would be a good time to remove the WIP label from the PR.
        - Likely after updating Mentee and Mentor sections is in a workable state + FAQs
* Should be rebasing but leave number of commits
* Folder restructure, mentee/mentor page and FAQ
* GitHub doesnt have a redirection tool; maintainters have been notified, potential applicants will seek this information - work can be continued once ideas have been confirmed/agreed upon, possibly next week.
Q. Keep v1 page blank with link to v2 page
Edit page we would link to, highlight page move. Can hold off on this until the last minute; let's keep it clean in the meantime. 

Links important to share with others - Mentoring tree main, LFX Mentorship 2022... [link](https://github.com/cncf/mentoring/tree/main/lfx-mentorship/2023/01-Mar-May)

## January 10, 2023

21:00 UTC (1:00 PM PST on 2023-01-10; 10:00 AM NZST on 2023-01-11)

### Attendance

* Nate W.
* Riaan K.
* Asare N.
* Josh Berkus
* Alexandre N.

### Updates/reminders

* [2022 Meeting Minutes](https://hackmd.io/@tag-cs-mentoring-wg/monthly-meeting) file has been set to read only for most users and [is being archived](https://github.com/cncf/mentoring/pull/756).

### Agenda

* Mentoring WG Calendar https://calendar.google.com/calendar/u/0?cid=Y18wNTMzNWEwNDhjYjMyNTk3NTRmZjAzYzgwM2MyN2FjMDhmMjFkZTc4OTYyMDhkMmI1NWFjMmM1MTIzNDlhZDFiQGdyb3VwLmNhbGVuZGFyLmdvb2dsZS5jb20
* LFX Mentorship Project proposals open Jan 16
  * https://github.com/cncf/mentoring/tree/main/lfx-mentorship/2023/01-Mar-May
  * email toc mailing list
* Repo revisions - to create a work session to discuss/rework.
* [Nate W.] Do we still need the temp 2nd monthly meeting? (We should defer this question to a meeting that Jay can attend)
* KubeCon Amsterdam
    * workshop re: how to be a good mentor (proposal writing, selecitng mentees, etc.)
    * Speed mentoring co-operation
      * find out who to chat with about this
* 2023 Mentorship goals
  * Increase diversiy of participants
      * How do we increase awareness in  geographical diverse places?
      * Students in academic communities in new locations
          * LM
          * Africa
  * 150 mentees participating across all programs
  * work with LF research team to better understand trends
  * work with LF training to create a training course for mentors
  * work with LF mentoring admins to reach out to universities to work with co-op programs
  * increase number of programs we participate in
      * ex. Outreachy
      * recruit community members to help manage/run the programs
  * others?
    * [name=Nate W.][time=Thu, Jan 12, 2023 10:05 AM] Look into creating a 2-term program for longer/larger projects (How would this work with the req that mentees can only participate in one mentorship)
    * [name=Nate W.][time=Thu, Jan 12, 2023 1:13 PM] Reduce percentage of failed/withdrawn mentees
    
* Organize projects (and SIGs and TAGs) to supply an ongoing list of mentorship opportunities based on the Clotributor.
    * https://clotributor.dev/
    * That way we can reach out based on existing tasks
    * Plus skim a list of potential mentors
* Participate in MC, doing session on "participating in mentorship programs"
    * Nate + 1-2 project maintainers who did mentorships


---

# Meeting Template

## March 14, 2023

21:00 UTC (2:00 PM PDT on 2023-01-10; 10:00 AM NZST on 2023-01-11)

### Attendance

* 

### Updates/reminders

* 

### Agenda

* 

### Notes

* 

---

# Archives

* [2022 Meeting Minutes](https://github.com/cncf/mentoring/blob/main/TAGCS-Mentoring-WG/2022-meeting-minutes.md)
* [June 30, July 12, July 26, 2022](https://docs.google.com/document/d/1ZVFf_GRB5yrcTQieudtk3W-gWL6KuwHn1QG8XKdrARo/edit?usp=sharing)
