# Become a Mentee

Congratulations on choosing to take part in a mentorship program available with the CNCF and some of its valued members. Contributing as a mentee can be a rewarding and fulfilling experience that connects you with a range of experts and development opportunities unique to these programs. 

In addition to providing a high-quality learning experience that can help to kickstart your career, while adding tangible value to one of CNCF's 140+ open source projects; participating in mentorship programs also offer a range of other benefits that help both yourself and the CNCF community:
* **Community:** Your contribution matters! Participating in mentorship programs can help to strengthen the community and its work by fostering innovation and collaboration while improving overall project quality.
* **Network:** Learn and work alongside experts developing some of the most influential open source technologies in the world, as well as other passionate mentees eager to help bring these projects to life. 
* **Recognition:** Many programs offer stipends and other incentives to support your contribution. Amounts can be based on varying factors including your location or specific projects. 

Becoming a mentee in a CNCF mentorship program provides numerous benefits, including access to experienced professionals in the field, opportunities for personal and professional growth, and a supportive network for guidance and feedback. It can also help you to acquire new skills and knowledge, develop a deeper understanding of the industry, and increase your chances of success in your career.


## Mentee Expectations

Participating in a mentorship program can require a lot of time, effort and dedication. In exchange for that commitment, a seasoned mentor offers their valuable time and expertise to aid your learning and development. 

To ensure the experience is positive for everyone involved, there are a few key things you as a mentee can do to maximise your opportunity:

* **Make sure you can devote yourself to the minimum required hours throughout the program.** This can vary between projects, but often you will be expected to invest a significant amount of time on a weekly basis to your work.
To avoid confusion, *be realistic about how much time you can put into the program*, and communicate openly with your mentor to confirm your proposed commitment is also feasible for them.

* **Be open about your skill level.** Applying for opportunities that exceed your level of skill or experience can mean more work, and possibly frustration, for those involved as the program progresses. 
Even if you are selected for a project, it's important to have a transparent and honest conversation with your mentor(s) about the level of difficulty involved. This can help to establish a clear understanding and agreement about your ability to complete set tasks, and ensure you have the necessary resources to succeed. 

*Overall, having a positive experience in any mentorship program will be dependent on good communication, diligence and taking initiative.* Your mentors and the wider community are invested in your success, so being proactive and assuming responsibility for your progress is essential. 

## Support Networks

Having a solid support network provides a safe and productive environment for mentees to seek advice and receive guidance and feedback. It can be critical in navigating challenges and obstacles, building confidence, and feeling encouraged to continue your personal and professional growth.

* **Your relationship with your mentor** will be your most important connection throughout your program. In addition to providing valuable new skills and coaching, mentors can also support your professional networking and overall guidance in your career. Communicating any barriers to your learning or commitments and working together to find solutions can go a long way to developing a good working rapport.
* **Communication channels, groups and forums** such as Slack can be a great way to find solutions to common problems you'll likely encounter on your journey. Some popular options include:

[CNCF Slack channels](https://slack.cncf.io) such as **#mentoring**; where you can engage to share your knowledge to solve specific problems.

***Important Note:*** *It is not recommended to request general guidance or to express interest in working on issues that might be raised on these channels. Refer to the '[What is Contribution?](#what-is-contribution)' section in FAQs for the preferred process.*

[CNCF Community Groups and events](https://community.cncf.io/) - Conferences, workshops, and other events such as Meetups bring together individuals from the Cloud Native community to collaborate and share knowledge.

These and other support networks can provide you with opportunities to connect with others in the field, learn from experienced professionals, and gain a deeper understanding of cloud native technologies. 

Mentorship programs can be highly rewarding, yet challenging commitments to undertake. To make the most of your experience and improve your chances of success, be sure to reach out if:
* You're unsure about next steps in your mentorship or its requirements
* You're having doubts about your ability to complete your work
* You're looking for other development opportunties to support your work
* You're struggling to balancing your commitments, especially if they're affecting your health and well-being 

In summary, there are multiple contacts and resources available to guide you, and a supportive network can play a crucial role in the success and fulfillment of your mentorship experience.

## Programs

There are numerous open source mentoring and internship programs available, with each emphasising different criteria such as specific skillsets, demographics, industries and specialisations. 

Currently, the CNCF concentrates on a limited selection of such programs; featuring a range of projects to encourage interest from a broad pool of talent and backgrounds. 
These are as follows:

**LFX**  
The [Linux Foundation Mentorship program](https://docs.linuxfoundation.org/lfx/mentorship/mentee-guide/introduction), also known as '**LFX**', plays a crucial role in providing mentees, including students and both new and experienced programmers; with structured hands-on learning opportunities in open source software development. 
Through the program, mentees are paired with mentors based on their skills and interests to gain valuable experience by participating in and contributing to open source projects, all while [getting paid for it](https://docs.linuxfoundation.org/lfx/mentorship/mentees).
 
**Google Summer of Code**  
The [Google Summer of Code](https://summerofcode.withgoogle.com/), often abbreviated to GSoC, is an international annual program in which Google awards stipends to contributors who successfully complete a free and open-source software coding project during the summer. 

**Google Season of Docs**  
[Google Season of Docs](https://developers.google.com/season-of-docs/docs/organization-application-hints) is the ideal opportunity for aspiring and professional technical writers interested in non-code contribution, providing support for open source projects to improve their documentation. 

**Outreachy**  
[Outreachy](https://www.outreachy.org/apply/) has internship projects in both open source and open science, and is aimed at people subject to systemic bias or underrepresented in the technical industry where they are living. Projects may include programming, research, user experience, documentation, graphical design, data science, marketing, user advocacy and event planning.

*If you're interested in applying for one of these programs, be sure to read through the application details outlined in the links provided to determine your eligibility.*

### Selecting a program

If you're struggling to choose which program to apply for, there's a number of considerations to factor: 

1. ***Goals and expectations*** 
Determine what you hope to accomplish with the program and seek out opportunities that align with your aspirations and interests.
2. ***Industry expertise*** 
Choose a program that specializes in your preferred industry and offers mentors with relevant experience. Be sure to carefully review the required skills to ensure you can manage the workload.
3. ***Mentor-mentee fit*** 
Choose a program that matches you with a mentor whose skills, experience, and personality ideally align with your needs and goals. It can also help to study the project or company that mentor represents to gain an understanding of their values and the nature of their work.
4. ***Program structure*** 
Consider the program's format, length, and frequency of meetings to determine if it will provide the level of support and structure that you need. This is also important in deciding whether you can balance the time commitment with any existing responsibilities you might have.
5. ***Availability and accessibility*** 
Ensure that the program is accessible and that mentors are available to provide support and guidance. Consider things like location, timezones and potential language barriers which might impact your participation and development.
6. ***Feedback and evaluation:*** 
Look for programs that provide regular feedback and evaluations to help you track your progress and adjust your goals as needed.

As a final note, reach out to program graduates via the channels listed in the **'Support Networks'** section for guidance; or review related blogs, articles or videos to help inform your decision. 

To maximize the benefits of a mentorship program, it is important to choose one that aligns with your personal goals and objectives. Each program has its own unique strengths and benefits, so by applying and learning more about the experience as it progresses, you can ensure that you select the best program for your needs.


## Remuneration

> **How do people find paid work through Open Source contribution?**

*(Points/questions for consideration as below)*

**What are the job roles and job descriptions that are available in the industry?**

**How long does it generally take for someone to start earning?**

**What can I do to increase my employability/attractiveness to potential employers?**

## Skills & Experience

As a contributor and potential mentee, it's important to have a diverse technical and professional skillset in order to make the most impact. CNCF projects rely on a wide range of skills to thrive, including software development, design, project management, documentation, testing, and more.

***Choosing a project to contribute to***

Selecting a project according to: *(paragraph needed)*
* personal interests and preferences
* existing or desired skills such as specific programming languages
* reviewing the [CNCF Landscape](https://landscape.cncf.io/) to gain an understanding of different projects and researching to determine the best match
* reviewing graduate profiles and communications such as blogs, Tweets and **Success Stories** to learn more about individual experiences. 

***Developing as a professional alongside your mentor***
Your technical experience will be critical to your work during your mentorship. Professional excellence however can only be achieved by balancing that knowledge with 

Whether you are a developer, designer, or anything in between, there is a place for you in mentoring programs on offer, and your unique skills and perspectives will be valuable assets to any project you choose to contribute to.

* Provide general overview of skills common in recent LFX projects e.g. Go (provide link to skills map or similar resource from previous intake as indication?)
* Dependent on individual projects, subject to change over time
* Emphasise soft skills such as communication; critical regardless of technical expertise required

## Success Stories

*(Refer to existing repo content; additions as required)*

---


# FAQs

#### I’m new to Open Source and CNCF. Where should I start?

Welcome to the community! It would be good to note before diving in, that there is no singular way to become a Contributor. Like most careers, your path will be determined by your unique goals, skills, personality, commitment, and available opportunities over time. 

_Article_: "[Do you want to start contributing to open source and need help figuring out where to begin?](https://contribute.cncf.io/contributors/getting-started/)"

There are however a few proven areas you can check out to get the ball rolling:

* If you're completely new to Open Source, there are countless blogs, articles, videos and resources that can be located with a simple web search. There are also popular short courses available, such as those offered by [Linux](https://trainingportal.linuxfoundation.org/learn/course/a-beginners-guide-to-open-source-software-development-lfc102/course-introduction/course-information) or [EDX](https://www.edx.org/course/open-source-software-development-linux-for-developers?index=product&queryID=54e7a9a4b82d487dd017ff72baabd439&position=2) that will help you to learn the fundamentals quickly.
* Understand that contributions can be either code-based (technical skills required) and non-code (improving documentation, offering feedback), depending on the needs of specific projects.
* **If you have some basic experience**, check out the following for different opportunities:
    * Many sites related to CNCF and its projects, like the [CNCF Contributor page](https://contribute.cncf.io/contributors/), will have Contributor guides which outline tasks; as well as lists with several actions you can take to begin your contributor journey.
    * [CLOTributor](https://clotributor.dev/) is a searchable database with dozens of tasks from [Cloud Native projects](https://www.cncf.io/projects/) you can tackle to build your experience.
    This can be a great way to familiarise yourself with various projects before choosing to commit to one offered in a specific mentorship program.
    * Look for issues labeled 'good first issue'. You may also want to start with some of the documentation projects (like the website itself). This is often a good place to start when learning about a new project and looking to contribute.

**Final piece of advice:** The best way to start is contribute immediately; make mistakes and learn from them. This will help you to get familiar with different processes and community members as your work is reviewed, evaluated or approved. 

---

#### What is 'Contribution'?
Simply put, contribution is about adding value by giving back. The open source community thrives on the efforts of its millions of members globally to help shape, develop and maintain its systems and infrastructure, one incremental step at a time.

Whether you're fixing a minor typo in documentation, or your code is helping to create the next game-changing project, every (approved!) action you make towards development is a critical piece of a bigger puzzle.

Being active in GitHub, meetings, events and blogs or articles are also examples of contribution that show your commitment and consistency, and overall will help both your own journey and the wider community over time.

The best way to start contributing is:
* Learn how to use the project, read the docs, try the tutorial/quickstart, and find ways to gain experience using the project and understanding how it works
* Read the [CONTRIBUTING](https://github.com/cncf/tag-contributor-strategy/blob/main/CONTRIBUTING.md) guide.
* Volunteer to work on an open issue that you know how to fix.
* Attend [meetings or join our Slack channel](https://github.com/cncf/tag-contributor-strategy#communicating-with-us).
* Contribute a bug fix for a problem that is impacting you.

The CNCF Contributor website is a great starting point for new contributors. 

---

#### Can I contribute if I don't have a tech background?

Absolutely. In addition to the countless code-based efforts available in the open source community, there are also numerous roles and opportunties to contribute that don't require specific technical experience.

Documentation, community engagement, project management and even blogging about your experiences in the space are all beneficial to the overall growth and sustainability of the community.

Take some time to explore [relevant articles and resources] that can provide more clarity in different options available to you.

Example reference(s): TBC

---

#### What's the best way to communicate with the community or get support with questions?

There are various communication channels/platforms the open source community uses to interact (Slack, Discussion Boards etc.); whether providing support, coordinating work or recognising contribution for instance.

To ensure that any responses to your questions don’t get split across platforms, stick to one channel at a time so answers can be collected in one space and are easier for others to reference in the future.

**I'm excited about contributing to Open Source with CNCF but overwhelmed by its complexity. How else can I build my understanding?**
OS can be jargon-heavy, getting familiar with the vocab/terminology can be helpful
If in doubt, reach out - the community is built upon supportive relationships
Example reference(s): (Paragraph) CNCF Glossary

**What are the benefits to becoming a Mentee?**
* Skills, experience and confidence
* Guidance from industry experts
* Internationally-recognised programs
* Networking opportunity; employers and community

---

**How do I apply?** 
*(see 'Programs' section)*

---

**What if I'm not skilled/experienced enough to participate yet?**
Suggest complementary short courses to upskill
Continue to interact with the community to build experience and understanding

**What support is available during mentorships?**
Mentorship programs such as LFX and Google Summer of Code are coordinated by various Maintainers who help to facilitate your experience.

Questions, feedback, liaising between involved parties
Mentors provide guidance, encouragement and expertise
Community e.g. other mentees
Support system in ongoing development according to identified need

**I'm applying for LFX and am interested in a project, but am stuck on next steps. What should I do?**
[Looking through the projects] (link needed) will highlight suggested skills, so hopefully, something in this resource will match your skillset.

Each project has a link to a corresponding GitHub issue, so if you see something interesting, use this to reach out to the relevant project Maintainers. This will help you both get a sense of your suitability and what is needed to progress.

**Are mentorships suitable for career changers?**
LFX eligbility criteria requires that you are not a maintainer, recurring contributor, etc. with more than minimal involvement with the open source project that offers a mentorship program.

Check out the eligibility guide for full information.

**I think I've missed the deadline to apply! Can I still submit my application?**
*State date flexibility or not? - Especially re LFX* (TBC)
(Additional miscellaneous)

* Support tickets for specfic issues e.g. application process
* Career Paths


(Additional miscellaneous)

## **Full List FAQs** (final TBC)
1. I'm new to Open Source and CNCF, where should I start?
1. What is 'Contribution' (in all its forms?)
1. Can I contribute if I don't have a tech background?
1. What's the best way to communicate with the community or get support with questions?
1. What are the benefits to becoming a Mentee?
1. How do I apply to programs? 
1. What if I'm not skilled/experienced enough to participate yet?
1. I'm applying for LFX and am interested in a project, but am stuck on next steps. What should I do?
1. What support is available during mentorships?
1. Are mentorships suitable for career changers?
1. I think I've missed the deadline to apply! Can I still submit my application?
1. Are roles in Open Source typically for teams or individuals?
1. What sort of companies would be looking for these roles?
1. What is the scope of income that is possible in the different roles?
1. What are common skills needed for various roles (vs. mentorships specifically) e.g. technical and personal?
1. What is the training pathway, certifications or internships needed for each role?
1. Are qualifications essential to obtain work?
1. I've tried reaching out in Slack communities, but it's confusing/overwhelming/intimidating. How can I better navigate this space?
1. I've attended meetings, but I don't feel experienced enough to participate. How can I better interact with this aspect of the community?
1. What's the best piece of advice for someone starting out?

---
