---
maintainers:
- caniszczyk
- idvoretskyi
- zacharysarah
- celestehorgan
---

# Google Season of Docs 2021

Google [Season of Docs](https://developers.google.com/season-of-docs) (GSoD) gives technical writers an opportunity to work with open source projects.

The CNCF is applying to participate in GSoD 2021!

## 2021 Timeline

Google Season of Docs 2021 makes numerous change to the program from previous years:

1. GSoD 2021 permits only one project proposal per organization. 

   This marks a significant change from the multiple proposals allowed in previous years. 

1. GSoD 2021 starts earlier and runs longer! Projects begin in April/May and run until November.

1. Project proposals include a new requirement for budgeting.

   For more information, see the [proposal template](https://developers.google.com/season-of-docs/docs/org-proposal-template).

### What's happening right now?

Date | Activity
---|---
March 26, 2021 | The CNCF has submitted a [project proposal](#project-proposal) for consideration.

All steps are based on the [GSoD 2021 timeline](https://developers.google.com/season-of-docs/docs/timeline).

## Project Proposal

Reorganize Contour’s documentation

### What's the problem?

The information architecture for [Contour](https://projectcontour.io) needs help: 

- Headings focus on functionality rather than user tasks 
- There’s an abundance of familiar terms overloaded with new definitions
- Information is organized haphazardly and inconsistently
- The new user experience is confusing, with artificially high barriers to entry

Help Project Contour reorganize its documentation around a user's task flow and improve documentation navigability.

### How would we measure success?

- Shorter onramp time for new users
- Increased support deflections by using docs 
- Docs provide effective 1 to many support, measured in fewer requests for 1:1 support from project team
- Create a getting started guide for new Contour users
- Optimize content for actual developer and user workflows
- Provide consistent presentation: adhere to style guide, headings are consistent, and language is grammatically correct

### What skills does a writer need?

Required:
- Familiarity with Git, Markdown and Hugo 

Nice to have:
- Distributed systems experience: networking, containers, Kubernetes and Envoy in particular

### Volunteers

- @celestehorgan – Lead for technical writing mentorship; approver for work
- @jonasrosland – Main point of contact for Contour and approver for work
- @stevesloka, @krisss, @youngnick – Technical experts and PR approvers

### Budget

Total budget: $15,000 USD

Writer: $14,350
Volunteers: 4 @ $100
Stickers: $100
T-shirts: $150

### Contact info

**Before applying**, please note:

- Email is the only acceptable channel for contact about GSoD. 
- Do not contact admins about GSoD via chat apps or in any other channel.
- The program page for [Google Season of Docs](https://developers.google.com/season-of-docs/docs) is the best source of information for questions about the program, including [relevant dates](https://developers.google.com/season-of-docs/docs/timeline). 

To apply, send an email to [mentoring@cncf.io](mailto:mentoring@cncf.io). Include links to examples of your technical writing portfolio and résumé/CV.

## Previous years

| Year | Term | Status   | Announcement           | Details              |
|------|------|----------|------------------------|----------------------|
| 2020 | Q2   | Accepted | http://goo.gle/2WOt8xs | [Q2'2020](previous-years/2020/README.md) |
