# LFX Mentorship by The Linux Foundation

[LFX Mentorship](https://lfx.linuxfoundation.org/tools/mentorship/) (previously known as Community Bridge) is a platform developed by the Linux Foundation, which accelerates the adoption, innovation, and sustainability of open source software.

LFX Mentorship is actively used by the Cloud Native Computing Foundation as a mentorship platform across the CNCF projects.

- [LFX Mentorship](#lfx-mentorship)
  - [Program Cycles and Archive data](#program-cycles-and-archive-data)
    - [Current cycle](#current-cycle)
  - [Program Maintainers](#program-maintainers)
  - [Communication](#communication)
  - [Program Guidelines](#program-guidelines)
    - [How to apply?](#how-to-apply)
      - [Projects](#projects)
      - [Mentors](#mentors)
      - [Mentees](#mentees)
        - [Eligibility](#eligibility)
    - [Mentee selection process](#mentee-selection-process)
    - [Stipends](#stipends)

## Program Cycles and Archive data

| Year | Term             | Status    | Announcement                                                                                                                                                                                                                                                                   | Details                                             |
|------|------------------|-----------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------------------------------------------|
| 2025 | Term 2: Jun-Aug  | In prorgess |                                                                                                                                                                                                                                                                                | [2025 Term 2: Jun-Aug](2025/02-Jun-Aug/README.md)   |
| 2025 | Term 1: Mar-May  | Completed |                                                                                                                                                                                                                                                                                | [2025 Term 1: Mar-May](2025/01-Mar-May/README.md)   |
| 2024 | Term 3: Sep-Nov  | Completed |                                                                                                                                                                                                                                                                                | [2024 Term 3: Sep-Nov](2024/03-Sep-Nov/README.md)   |
| 2024 | Term 2: Jun-Aug  | Completed | [Congratulations to 45 CNCF Term 2 2024 LFX Program mentees!](https://www.cncf.io/blog/2024/09/27/congratulations-to-45-cncf-term-1-2024-lfx-program-mentees/)                                                                                                                 | [2024 Term 2: Jun-Aug](2024/02-Jun-Aug/README.md)   |
| 2024 | Term 1: Mar-May  | Completed | [CNCF celebrates successful mentees from LFX Program Term 1 2024!](https://www.cncf.io/blog/2024/06/19/cncf-celebrates-successful-mentees-from-lfx-program-term-1-2024/)                                                                                                       | [2024 Term 1: Mar-May](2024/01-Mar-May/README.md)   |
| 2023 | Term 3: Sep-Nov  | Completed | [LFX Program’s CNCF mentees have successfully finished Term 3!](https://www.cncf.io/blog/2023/12/14/lfx-programs-cncf-mentees-have-successfully-finished-term-3/)                                                                                                              | [2023 Term 3: Sep-Nov](2023/03-Sep-Nov/README.md)   |
|      | Term 2: Jun-Aug  | Completed | [36 CNCF term 2 LFX mentees have successfully completed the program!](https://www.cncf.io/blog/2023/09/12/36-cncf-term-2-lfx-mentees-have-successfully-completed-the-program/)                                                                                                 | [2023 Term 2: Jun-Aug](2023/02-Jun-Aug/README.md)   |
|      | Term 1: Mar-May  | Completed | [Congratulations to 57 CNCF Term 1 LFX Program Mentees!](https://www.cncf.io/blog/2023/06/09/congratulations-to-57-cncf-term-1-lfx-program-mentees/)                                                                                                                           | [2023 Term 1: Mar-May](2023/01-Mar-May/README.md)   |
| 2022 | Term 3: Sept-Nov | Completed | [Congratulations to 24 CNCF fall term LFX Program mentees! ](https://www.cncf.io/blog/2022/12/08/congratulations-to-24-cncf-fall-term-lfx-program-mentees/)                                                                                                                    | [2022 Term 3: Sept-Nov](2022/03-Sept-Nov/README.md) |
|      | Summer           | Completed | [Congratulations to the 27 Summer LFX Program CNCF interns!](https://www.cncf.io/blog/2022/10/03/congratulations-to-the-27-summer-lfx-program-cncf-interns/)                                                                                                                   | [Summer'2022](2022/02-Summer/README.md)             |
|      | Spring           | Completed | [CNCF congratulates 36 successful interns with Spring Term LFX Program!](https://www.cncf.io/blog/2022/07/07/cncf-congratulates-36-successful-interns-with-spring-term-lfx-program/)                                                                                           | [Spring'2022](2022/01-Spring/README.md)             |
| 2021 | Fall             | Completed | [CNCF LFX projects are open for Fall 2021 – Apply by August 22nd!](https://www.cncf.io/blog/2021/08/16/cncf-lfx-projects-are-open-for-fall-2021-apply-by-august-22nd)                                                                                                          | [Fall'2021](2021/03-Fall/README.md)                 |
|      | Summer           | Completed | [CNCF LFX Projects are Open for Summer 2021 – Apply by May 17th!](https://www.cncf.io/blog/2021/05/04/cncf-lfx-projects-are-open-for-summer-2021-apply-by-may-17th)                                                                                                            | [Summer'2021](2021/02-Summer/README.md)             |
|      | Spring           | Completed | [CNCF LFX Projects are Open for Spring Term 2021! Apply Now for a Mentorship Opportunity!](https://www.cncf.io/blog/2021/02/03/cncf-lfx-projects-are-open-for-spring-term-2021-apply-now-for-a-mentorship-opportunity/)                                                        | [Spring'2021](2021/01-Spring/README.md)             |
| 2020 | Q3-Q4            | Completed | [CNCF will participate in CommunityBridge Mentorships for Q3 and Q4 2020](https://www.cncf.io/blog/2020/09/04/cncf-will-participate-in-communitybridge-mentorships-for-q3-and-q4-2020/)                                                                                        | [Q3-Q4'2020](2020/q3-q4/README.md)                  |
|      | Q2               | Completed | [21 CNCF interns graduate from the Q2 2020 Linux Foundation CommunityBridge Program](https://www.cncf.io/blog/2020/08/13/21-cncf-interns-graduate-from-the-q2-2020-linux-foundation-communitybridge-program/)                                                                  | [Q2'2020](2020/q2/README.md)                        |
|      | Q1               | Completed | [Seven CNCF interns graduate from the 2020 Linux Foundation CommunityBridge Program](https://www.cncf.io/blog/2020/04/15/seven-cncf-interns-graduate-from-the-2020-linux-foundation-communitybridge-program/)                                                                  | [Q1'2020](2020/q1/README.md)                        |
| 2019 | Pilot            | Completed | [CNCF hosts three student internships for Kubernetes and CoreDNS projects through Linux Foundation’s CommunityBridge](https://www.cncf.io/blog/2019/08/22/cncf-hosts-three-student-internships-for-kubernetes-and-coredns-projects-through-linux-foundations-communitybridge/) | [2019](2019/README.md)                              |

### Current cycle

The current cycle is [01-Mar-May 2025](2025/01-Mar-May/README.md).

## Program Maintainers

- Nate W. ([@nate-double-u](https://github.com/nate-double-u))

## Program Guidelines

Please see the program-wide guidelines on the [LFX Mentorship website](https://docs.linuxfoundation.org/lfx/mentorship).

### How to apply?

#### Projects

Project maintainers and mentors are requested to submit the ideas using the [template](/PROJECT_IDEA_TEMPLATE.md).

CNCF will select the projects that will participate in the LFX mentorship round and they will appear on the LFX Mentorship Platform website after the selection.

#### Mentors

If you are a mentor and your project will be selected to participate in the LFX Mentorship program, you'll have to apply as a mentor on the LFX Mentorship website. Please see the [LFX Mentorship guidelines](https://docs.linuxfoundation.org/lfx/mentorship/mentor-guide) for more details.

#### Mentees

If you are a mentee and your desired project will be selected to participate in the LFX Mentorship program, you'll have to apply as a mentee on the LFX Mentorship website. Please see the [LFX Mentorship guidelines](https://docs.linuxfoundation.org/lfx/mentorship/mentee-guide) for more details.

Information on the application process is covered at the [LFX Mentorship documentation website](https://docs.linuxfoundation.org/lfx/mentorship/mentees/apply-to-a-project). Please note that once you've applied, your application moves to the pending state until a mentor will pick it up. There is no need to reapply (you'll see an error if you'll try to reapply).

The stipend guides and amounts are listed [here](https://docs.linuxfoundation.org/lfx/mentorship/mentee-stipends).

##### Eligibility

**Please see the full eligibility criteria in the [LFX Mentorship documentation](https://docs.linuxfoundation.org/lfx/mentorship/mentees)**.

### Mentee selection process

Mentors are responsible for selecting and matching mentees to their projects.

* Mentees must be chosen based on who is the best fit for the project. In addition to technical skills and qualifications, the person's ability to work well with others is a valid factor. Only if two candidates are equally qualified may a mentor use diversity-related considerations as a tie-breaker.

* A mentor must not participate in selection of the mentee for a particular mentorship if there is a conflict of interest. A conflict of interest exists if a family member, member of the same household, close personal friend, or romantic partner has applied for the mentorship, or if there is any other reason why the mentor could not be deemed impartial in the selection process.

Mentee candidates are required to provide cover letters (Statement of Purpose) while applying, so mentors may review them. In addition, mentors may also interview the candidates to understand their level of qualification before making the final decision.

If you are a mentee, please note that you'll be asked to provide the Statement of Purpose letter after the mentor's selection. Please be patient.

### Stipends

The LFX Mentorship stipend policy is described here - <https://docs.linuxfoundation.org/lfx/mentorship/mentee-stipends>.

## Communication

If you have any questions or issues with the LFX Mentorship platform/website itself, payments, etc., contact the [LFX Mentorship support team](https://support.linuxfoundation.org/) directly.

For CNCF-specific questions:

- Use the [CNCF mentoring discussions board](https://github.com/cncf/mentoring/discussions)
- Write to mentoring@cncf.io **only for questions that _can not_ be asked publicly**

> [!IMPORTANT]
> **_Do not_ directly message program maintainers or project mentors**.

